program bin2cbm;
(* ROMs binaer -> CBM-Format *)

uses crt;

var file1, file2:   file of byte;
    name1,name2:    string[80];
    filecount:      integer;
    ok:             Boolean;
    ch:             char;
    i:              integer;
    ad:             longint;
    by:             byte;

procedure hexout(x: longint; digits:integer);
  var i,j: integer;
      y:   longint;
  begin
    write('$');
    for i:=pred(digits) downto 0 do begin
     j:=i shl 2;
      y:=x shr j;
      x:=x-(y shl j);
      if y>9 then write(chr(y+87))
             else write(y)
    end;
    writeln
  end;

function hex2int(s: string): longint;
var i, j:    integer;
    x:       longint;
    c:       char;
    h1, h2:  string;
begin
  h1 := '0123456789abcdef';
  h2 := '0123456789ABCDEF';
  x := 0;
  for i := 1 to Length(s) do begin
    c := s[i];
    for j := 1 to 16 do
      if (c=h1[j]) or (c=h2[j]) then
        x := 16 * x + (j-1)
  end;
  hex2int := x;
end;

begin
  writeln('BIN2CBM.EXE :');
  writeln('wandelt ROM-images von Binrdatei in CBM-Format');
  writeln('(fgt Adress-Header hinzu)');
  writeln('Woll, 8/97');
  writeln;

  filecount := 0;
  ok := (paramcount > 2);

  if not ok then
    writeln('Aufruf:  BIN2CBM <Quelldatei> <Zieldatei> <HEX-Adresse> !!');

  if ok then begin
    name1 := paramstr(1);
    name2 := paramstr(2);
    ad := hex2int(paramstr(3));
    ok := (name1<>name2);
    if not ok then
      writeln('Quelldatei mu ungleich Zieldatei sein !');
  end;

  if ok then begin
    write('Quellfile: '); writeln(name1);
    write('Zielfile:  '); writeln(name2);
    write('Start: ');
    hexout(ad,4);
    write('ok ? (j/n) ');
    repeat
      ch := readkey;
    until (ch in ['j','J','n','N']) or (ord(ch) = 27);
    ok := ch in ['j','J'];
    writeln;
  end;

  if ok then begin
    assign (file1,name1);
    (*$I-*);
    reset(file1);
    (*$I+*);
    ok := (IOresult=0);
    if ok then
      filecount := 1
    else begin
      filecount := 0;
      writeln('Quelldatei konnte nicht geffnet werden !');
    end;
  end;
  if ok then begin
    assign (file2,name2);
    (*$I-*);
    rewrite(file2);
    (*$I+*);
    ok := (IOresult=0);
    if ok then
      filecount := 2
    else
      writeln('Zieldatei konnte nicht erstellt werden !');
  end;

  if ok then begin
    by := ad mod 256;
    write(file2, by);
    ok := IOresult=0;
  end;
  if ok then begin
    by := ad div 256;
    write(file2, by);
    ok := IOresult=0;
  end;
  while ok and not eof(file1) do begin
    read(file1, by);
    ok := IOresult=0;
    if ok then begin
      write(file2, by);
      ok := IOresult=0;
      ad := succ(ad);
    end;
  end;

  if filecount > 0 then
    close (file1);
  if filecount > 1 then
    close (file2);
  if ok then begin
    write('Ende:  ');
    hexout(ad-1,4)
  end
  else
    writeln('abgebrochen !');
  writeln;
end.
