program dos2d64;
(* Mit LHA2Numb umbenannte, mit LHA entpackte, durchnumerierte
   Dateien in virtuelle .D64-Disks schreiben                    *)
uses crt;

CONST RecSize =  256;
      maxtrack = 35;
      maxsect = 20;

      Skips: array[1..5,0..maxsect] of Byte =
        ((11,12,13,14,15,16,17,18,19,20,255,1,2,3,4,5,6,7,8,9,10), { 1-17  }
         (1,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,3,255,2,0,0),   { 18    }
         (10,11,12,13,14,15,16,17,18,255,1,2,3,4,5,6,7,8,9,0,0),   { 19-24 }
         (10,11,12,13,14,15,16,17,9,255,1,2,3,4,5,6,7,8,0,0,0),    { 25-30 }
         (9,10,11,12,13,14,15,16,255,1,2,3,4,5,6,7,8,0,0,0,0));    { 31-35 }
      (* Sektoren-Reihenfolge:
         1-17:  0,11,1,12,2,13,3,14,4,15,5,16,6,17,7,18,8,19,9,20,10
         18:    0,1,4,7,10,13,16,3,6,9,12,15,18,2,5,8,11,14,17
         19-24: 0,10,1,11,2,12,3,13,4,14,5,15,6,16,7,17,8,18,9
         25-30: 0,10,1,11,2,12,3,13,4,14,5,15,6,16,7,17,8,9
         31-35: 0,9,1,10,2,11,3,12,4,13,5,14,6,15,7,16,8
      *)


type tBuf = array[0..maxsect,0..RecSize-1] of Byte;

var testfile:                          file of byte;
    readfile, diskfile:                file;
    listfile:                          text;
    tf, rf, df, lf, ok:                boolean;
    flen:                              longint;
    name0,name1,name2,name3,ftype,dirname:   string;
    inbuf:                             array[1..RecSize] of Byte;
    trackbuf, dirtrack:                tBuf;
    sectskip:                          array[1..maxtrack,0..maxsect]of Byte;
    x, y, i, j, inbyte, outbyte:       integer;
    
    track, sect, blocksfree:           integer;
    dirsect,dirbyte, disknr:           integer;
    upper:                             char;

procedure Cleartrack(var buf: tbuf);
  var i, j: integer;
  begin
    for i := 0 to maxsect do
      for j := 0 to pred(RecSize) do
        buf[i,j] := 0;
  end;

procedure Writetrack(var buf: tbuf; track: integer);
  var i, count: integer;
  begin
    count := maxsect;
    while sectskip[track,count] = 0 do
      count := pred(count);
    (*$I-*);
    BlockWrite(diskfile, buf, 2*succ(count));
    (*$I+*);
    ok := (IOresult=0);
    if not ok then
      writeln('Fehler beim Schreiben von track ',track);
  end;

procedure setbam(t1,t2:integer; b1,b2,b3,b4:Byte);
  var i: integer;
  begin
    for i := t1 to t2 do begin  (* BAM *)
      dirtrack[0,4*i] := b1;
      dirtrack[0,4*i+1] := b2;
      dirtrack[0,4*i+2] := b3;
      dirtrack[0,4*i+3] := b4;
    end;
  end;

procedure BAlloc(t, s: integer);
  var i: integer;
      x: byte;
  begin
    dec(dirtrack[0,4*t]);
    i := 4*t+1+(s div 8);
    x := 1 SHL (s mod 8);
    dirtrack[0,i] := dirtrack[0,i] and (not x);
  end;

procedure OpenDiskFile;
  var name, s: string;
      i:       integer;
  begin
    inc(disknr);
    str(disknr,s);
    name := dirname;
    i := 1;
    repeat
      name := name+name0[i];
      inc(i);
    until (i>length(name0)) or (i > 7-length(s));
    name := name+'_'+s+'.D64';
    assign (diskfile,name);
    (*$I-*);
    rewrite(diskfile);
    (*$I+*);
    ok := (IOresult=0);
    if ok then begin
      writeln('Erzeuge Diskfile "', name,'"');
      df := true;

      track := 1;
      sect := 0;
      ClearTrack(TrackBuf);

      ClearTrack(dirtrack);
      dirtrack[0,0] := 18;
      dirtrack[0,1] := 1;
      dirtrack[0,2] := 65;
      setbam( 1,17, $15,$FF,$FF,$1F);
      setbam(18,24, $13,$FF,$FF,$07);
      setbam(25,30, $12,$FF,$FF,$03);
      setbam(31,35, $11,$FF,$FF,$01);
      BAlloc(18,0);
      BAlloc(18,1);
      for i := 144 to 170 do
        dirtrack[0,i] := 160;
      for i := 1 to length(name0) do
        dirtrack[0,143+i] := ord(name0[i]);
      dirtrack[0,162] := ord(name0[1]);
      dirtrack[0,163] := ord(name0[2]);
      dirtrack[0,165] := 50;
      dirtrack[0,166] := 65;

      dirtrack[1,1] := 255;
      dirsect := 1;
      dirbyte := 0;
      blocksfree := 664;
    end
    else
      writeln('Diskfile "', name, '" konnte nicht erzeugt werden !');
  end;

procedure CLoseDiskFile;
  begin
    while ok and (track < 36) do begin
      WriteTrack(trackbuf, track);
      inc(track);
      Cleartrack(trackbuf);
    end;
    if ok then begin
      seek(diskfile, 17*21*2);
      writeTrack(dirtrack, 18);
      close(diskfile);
    end;
    df := false;
  end;

procedure WriteSect(chain:boolean);
  var nexttrack, nextsect: integer;
  begin
    (* next sector on this track: *)
    nexttrack := track;
    nextsect := sectskip[track,sect];
    if chain then begin
      trackbuf[sect,0] := nexttrack;
      trackbuf[sect,1] := nextsect;
    end;

    (* track full ? *)
    if nextsect > maxsect then begin
      inc(nexttrack);
      nextsect := 0;
      if nexttrack = 18 then begin
        inc(nexttrack);
      end;
      if chain then begin
        trackbuf[sect,0] := nexttrack;
        trackbuf[sect,1] := nextsect;
      end;

      writetrack(trackbuf,track);
      if nexttrack = 19 then begin
        writetrack(dirtrack,18);
      end;
      ClearTrack(trackbuf);
    end;
    Balloc(track,sect);
    track := nexttrack;
    sect := nextsect;
    outbyte := 2;
    inc(dirtrack[dirsect,dirbyte+30]); (* # Blocks *)
    dec(blocksfree);
  end;

function skip: char;
  var c: char;
  begin
    c := chr(0);
    while (ord(c)<33) and not eof(listfile) do
      read(listfile, c);
    skip := c;
  end;

function getname(var s: string): char;
  var c: char;
  begin
    s := '';
    read(listfile,c);
    while (c<>',')and(ord(c)<>0)and(c<>'"') do begin
      s := s+c;
      if c = '\' then
        s := '';
      read(listfile, c);
    end;
    getname := c;
  end;

begin
  writeln('DOS2D64.EXE :');
  writeln('DOS-Files entsprechend Namensliste mit CBM-Namen');
  writeln('in virtuelles .D64-Diskfile schreiben');
  writeln('Woll, 8/97');
  writeln;

  ok := (paramcount = 1);
  if not ok then
    writeln('Aufruf:  DOS2D64 <Verzeichnisname | Diskname> !!');

  upper := ' ';
  tf := false;  (* TestFile geschlossen *)
  rf := false; (* readfile geschlossen *)
  df := false;  (* diskfile geschlossen *)
  lf := false;  (* Listfile geschlossen *)
  disknr := 0;

  (* Skip-Folgen fuer tracks initialisieren: *)
  for sect := 0 to maxsect do begin
    for track := 1 to 17 do
      sectskip[track,sect] := skips[1,sect];
    sectskip[18,sect] := skips[2,sect];
    for track := 19 to 24 do
      sectskip[track,sect] := skips[3,sect];
    for track := 25 to 30 do
      sectskip[track,sect] := skips[4,sect];
    for track := 31 to 35 do
      sectskip[track,sect] := skips[5,sect];
  end;

  (* Listfile ffnen: *)
  if ok then begin
    name1 := paramstr(1);
    name0 := '';
    i := length(name1);
    while (name1[i] <> '\') and (name1[i] <> ':') and (i > 0) do begin
      name0 := upcase(name1[i])+name0;
      dec(i);
    end;
    dirname := '';
    while i > 0 do begin
      dirname := upcase(name1[i])+dirname;
      dec(i);
    end;
    
    name1 := dirname+name0+'\'+name0+'.LST';
    assign (listfile,name1);
    (*$I-*);
    reset(listfile);
    (*$I+*);
    if IOresult=0 then begin
      writeln('ffne Namensliste "', name1,'"');
      lf := true;
      dirname := dirname+name0+'\'
    end
    else begin
      writeln('Namensliste "', name1, '" konnte nicht geffnet werden !');

      name1 := dirname+name0+'.LST';
      assign (listfile,name1);
      (*$I-*);
      reset(listfile);
      (*$I+*);
      if IOresult=0 then begin
        writeln('ffne Namensliste "', name1,'"');
        lf := true;
      end
      else
        writeln('Namensliste "', name1, '" konnte nicht geffnet werden !');
    end;
  end;

  if ok then
     OpenDiskfile;

  if ok and lf then
    ok := (skip = '"') or eof(listfile);
  while ok and lf and not eof(listfile) do begin

    (* CBM-Filenamen und ggF. Filtype aus Listfile lesen: *)
    if ok then
      case getname(name1) of
        ',',chr(0):
          ok := (getname(ftype) = '"');
        else
          ftype := ' '
      end
    else
      writeln('Fehler in Namensliste: Zeile mu mit " beginnen !');

    (* DOS-Filenamen aus Listfile lesen: *)
    if ok then begin
      ok := (skip = ',');
      if ok then begin
        ok := (skip = '"');
        if ok then
          ok := (getname(name2) = '"')
        else
          writeln('Fehler in Namensliste: Name mu in "" stehen !');
      end
      else
        writeln('Fehler in Namensliste: Komma zwischen Namen fehlt !');
    end;

    (* Lnge des DOS-Files bestimmen *)
    if ok then begin
      name2 := dirname+name2;
      assign (testfile,name2);
      (*$I-*);
      reset(testfile);
      (*$I+*);
      ok := (IOresult=0);
      if ok then begin
        flen := filesize(testfile);
        close(testfile);
      end
      else
        writeln('Datei "', name2, '" konnte nicht geffnet werden !');
    end;

    (* DOS-File ffnen *)
    if ok then begin
      assign (readfile,name2);
      (*$I-*);
      reset(readfile);
      (*$I+*);
      ok := (IOresult=0);
      if ok then begin
        rf := true;
        write('"',name2, '" => "', name1, '" ');
        x := WhereX; y := WhereY;
        name3 := '';
        for i := 1 to length(name1) do
          name3 := name3 + upcase(name1[i]);
        if name1 <> name3 then begin
          if upper = ' ' then begin
            writeln;
            write('       Upcase ? (Yes/No/All/<Esc>) ');
            while (upper <> 'J') and (upper <> 'Y') and
                (upper <> 'N') and (upper <> 'A') and
                (ord(upper) <> 27) do begin
              upper := upcase(readkey);
            end;
            gotoxy(1,whereY);
            write('                                    ');
            gotoxy(1,whereY);
            if y = WhereY then
              dec(y);  (* scrolled *)
            gotoXY(x,y)
          end;
          case upper of
            'A','Y','J': begin
              name1 := name3;
              write('=> "', name1, '" ');
            end;
          end;
          case upper of
            'J','Y','N': upper := ' ';
          end;
        end;
        IF ftype<>' ' then
          writeln('(',ftype, ')')
        else
          writeln;
      end
      else
        writeln('Datei "', name2, '" konnte nicht geffnet werden !');
    end;

    (* Disk or directory full ? => new diskfile: *)
    if ok then begin
      if (flen > longint(blocksfree) * (RecSize-2)) or
         (dirsect > maxsect) then begin
        CloseDiskFile;
        if ok then
          OpenDiskfile;
        end;
    end;

    (* create directory-entry: *)
    if ok then begin
      case upcase(ftype[1]) of
        'D':
           if flen > 0 then begin
             writeln('  DEL-Files lnger als 0 !!! Wird als USR-File bertragen !');
             dirtrack[dirsect,dirbyte+2] := $83;
           end
           else
             dirtrack[dirsect,dirbyte+2] := $80;
        'S':
           dirtrack[dirsect,dirbyte+2] := $81;
        'U':
           dirtrack[dirsect,dirbyte+2] := $83;
        'R': begin
           writeln('  REL-Files !!! Wird als USR-File bertragen !');
           dirtrack[dirsect,dirbyte+2] := $83;
        end;
        else
           dirtrack[dirsect,dirbyte+2] := $82;
      end;
      if upcase(ftype[1]) = 'D' then begin
        dirtrack[dirsect,dirbyte+3] := 18;
        dirtrack[dirsect,dirbyte+4] := 1;
      end
      else begin
        dirtrack[dirsect,dirbyte+3] := track;
        dirtrack[dirsect,dirbyte+4] := sect;
      end;
      for i:= 5 to 20 do
        dirtrack[dirsect,dirbyte+i] := 160;
      for i:= 1 to length(name1) do
        if i < 17 then
          dirtrack[dirsect,dirbyte+4+i] := ord(name1[i]);
    end;

    (* Datei bertragen: *)
    inbyte := succ(RecSize);
    outbyte := 2;
    while (flen > 0) do begin
      if inbyte > RecSize then begin
        Blockread(readfile,inbuf,2,i);
        inbyte := 1;
      end;

      (* sector full ? *)
      if outbyte = RecSize then
        WriteSect(true);

      trackbuf[sect,outbyte] := inbuf[inbyte];
      trackbuf[sect,1] := outbyte;
      inc(inbyte);
      inc(outbyte);
      dec(flen);
    end;
    if upcase(ftype[1]) <> 'D' then
      WriteSect(false);

    close(readfile);
    rf := false;

    (* next directory entry: *)
    inc(dirbyte,32);
    if dirbyte >= RecSize then begin
      i := sectskip[18,dirsect];
      if i <= maxsect then begin
        dirtrack[dirsect,0] := 18;
        dirtrack[dirsect,1] := i;
        BAlloc(18,i);
      end;
      dirsect := i;
      dirtrack[dirsect,1] := 255;
      dirbyte := 0;
    end;

    if skip = '"' then; (* don't care *)
  end;

  if ok and df then
    CloseDiskFile;

  if lf then
    close(listfile);
  if rf then
    close(readfile);
  if df then
    close(diskfile);
end.